#include <GUIListView.au3>
Global $_RAS_
$checked = 0
$c = 0
Opt("GUIOnEventMode", 1)
#region GUI
$hGUI = GUICreate("Dateisuche", 436, 412, 192, 124)
GUISetOnEvent(-3, "_exit")
GUICtrlCreateLabel("Verzeichnis:", 4, 8, 79, 17)
$path = GUICtrlCreateInput("", 4, 40, 121, 21)
GUICtrlCreateLabel("Dateiname: ", 4, 88, 61, 17)
$filename = GUICtrlCreateInput("", 4, 120, 121, 21)
GUICtrlCreateLabel("Ergebnisse in eine Datei schreiben", 4, 153)
$log = GUICtrlCreateCheckbox("", 4, 167, 20, 20)
$search = GUICtrlCreateButton("Suchen", 4, 286, 75, 25)
GUICtrlSetOnEvent(-1, "search")
$results = GUICtrlCreateLabel("", 4, 266, 100, 15)
$showit = GUICtrlCreateListView("Pfad der Datei / des Ordners", 168, 16, 249, 370)
GUICtrlCreateLabel("Nur Dateien von einem " & @CRLF & "bestimmten Typ suchen", 4, 200, 130, 40)
$searchonlydatasfromspecialtype = GUICtrlCreateCheckbox("", 130, 203, 20, 20)
$filter = GUICtrlCreateInput("Dateiendung (z.B. .exe)", 4, 233, 140, 20)
GUISetState(@SW_SHOW)
#endregion GUI
While True
	sleep(20)
WEnd
Func search()
	_GUICtrlListView_DeleteAllItems($showit)
	If GUICtrlRead($log) = 1 Then $checked = 1
	GUICtrlSetData($results, "Ergebnisse: 0")
	AdlibRegister("update", 500)
	$result = _File_List_S_Rekursiv(GUICtrlRead($path))
	If GUICtrlRead($searchonlydatasfromspecialtype) = 1 Then
		If IsArray($result) Then
			GUICtrlSetData($results, "...")
			$y = 0
			For $x = 1 To $result[0]
				sleep(1)
				$test = StringRegExp($result[$x], GUICtrlRead($filename))
				$test2 = StringRegExp($result[$x], GUICtrlRead($filter))
				If $test = True And $test2 = True Then
					AdlibUnRegister("update")
					GUICtrlCreateListViewItem($result[$x], $showit)
					$y += 1
					If $checked = 1 Then FileWrite("Suchergebnisse.txt", $result[$x] & @CRLF)
				EndIf
			Next
			GUICtrlSetData($results, "Ergebnisse: " & $y)
		Else
			MsgBox(64, "Nichts gefunden", "Es wurde nichts gefunden")
			GUICtrlSetData($results, "Ergebnisse: 0")
			AdlibUnRegister("update")
		EndIf
	Else
		If IsArray($result) Then
			$y = 0
			GUICtrlSetData($results, "...")
			For $x = 1 To $result[0]
				sleep(1)
				$test = StringRegExp($result[$x], GUICtrlRead($filename))
				If $test = True Then
					AdlibUnRegister("update")
					GUICtrlCreateListViewItem($result[$x], $showit)
					$y += 1
					If $checked = 1 Then FileWrite("Suchergebnisse.txt", $result[$x] & @CRLF)
				EndIf
			Next
			GUICtrlSetData($results, "Ergebnisse: " & $y)
		EndIf
	EndIf
	AdlibUnRegister("update")
	If GUICtrlRead($results) = "Ergebnisse: 0." Or GUICtrlRead($results) = "Ergebnisse: 0.." Or GUICtrlRead($results) = "Ergebnisse: 0..." Then GUICtrlSetData($results, "Ergebnisse: 0")
EndFunc   ;==>search

Func update()
	If $c < 3 Then GUICtrlSetData($results, GUICtrlRead($results) & ".")
	If $c > 2 Then
		GUICtrlSetData($results, StringReplace(GUICtrlRead($results), ".", "") & ".")
		$c = 0
	EndIf
	$c += 1
EndFunc   ;==>update

Func _exit()
	Exit
EndFunc   ;==>_exit
#region UDF's
;===================================================================================================================================#
;~ Function Name....:  _File_List_S_Rekursiv($_Pfad_,  $_Wildc_ = '*', $_Flag_ = 0)
;
;~ Description......:  Auflistung von Dateien
;
;~ $_Pfad_..........:  Pfad
;~ $Wildc_..........:  '*' ( Standart ) Suchbegrif u. o. Wildcards bei Wildcards mit o. suchbegriff $_Flag_ auf '3' setzen es ist auch
;                      mglich mehrere suchbegriffe  zu suchen z.B  ( *wma,*mp3,*txt ) o. ( wma,mp3,txt ) getrennt mit ','
;~ $Flag............:  '0' ( Standart ) Datein u. Ordner '1' nur Datein '2' nur Ordner '3' um mit suchbegriffen zu suchen wie (*.txt)
;
;~ Return Value(s)..:  Array ( Standard )  mit den gefundenen Dateien u. o Ordner Array[0] endhlt die anzahl ( Fund )
;
;~ Author(s)........:  Kleiner27  (www.autoit.de)                                                           # 27.03.2010 09:00 #
;====================================================================================================================================#

Func _File_List_S_Rekursiv($_Pfad_, Const $_Wildc_ = '*', Const $_Flag_ = 0)
	$_Pfad_ = StringRegExpReplace($_Pfad_, '[\\/]+\z', '\') & '\'
	If Not FileExists($_Pfad_) Then Return SetError(1, 1, '')
	If StringRegExp($_Wildc_, '[\\/:><\|]|(?s)\A\s*\z') Then Return SetError(2, 2, '')
	If Not ($_Flag_ = 0 Or $_Flag_ = 1 Or $_Flag_ = 2 Or $_Flag_ = 3) Then Return SetError(3, 3, '')
	If ($_RAS_ <> '') Then $_RAS_ = ''
	_Rekursiv_S_($_Pfad_, $_Wildc_, $_Flag_)
	If Not $_RAS_ Then Return SetError(4, 4, '')
	Return StringSplit(StringTrimLeft($_RAS_, 1), '|')
EndFunc   ;==>_File_List_S_Rekursiv

Func _Rekursiv_S_($_Pfad_, $_Wildc_, $_Flag_)
	Local $_F_L_
	$_F_ = FileFindFirstFile($_Pfad_ & '*')
	If ($_F_ <> -1) Then
		While True
			$_F_N_ = FileFindNextFile($_F_)
			If @error Then ExitLoop
			$Expan = @extended
			Switch $_Flag_
				Case 0
					Switch $Expan
						Case 0
							$_RAS_ &= '|' & $_Pfad_ & $_F_N_
						Case 1
							$_F_L_ &= '|' & $_F_N_ & '\'
							$_RAS_ &= '|' & $_Pfad_ & $_F_N_
					EndSwitch
				Case 1
					Switch $Expan
						Case 0
							$_RAS_ &= '|' & $_Pfad_ & $_F_N_
						Case 1
							$_F_L_ &= '|' & $_F_N_ & '\'
					EndSwitch
				Case 2
					If ($Expan = 1) Then
						$_F_L_ &= '|' & $_F_N_ & '\'
						$_RAS_ &= '|' & $_Pfad_ & $_F_N_
					EndIf
				Case 3
					If ($Expan = 1) Then $_F_L_ &= '|' & $_F_N_ & '\'
					If StringRegExp($_F_N_, StringReplace(StringReplace($_Wildc_, '*', ''), ',', '|')) Then $_RAS_ &= '|' & $_Pfad_ & $_F_N_
			EndSwitch
		WEnd
	EndIf
	FileClose($_F_)
	If Not $_F_L_ Then Return $_F_L_ = '|'
	$_Verz_ = StringSplit(StringTrimLeft($_F_L_, 1), '|')
	$_UB_ = UBound($_Verz_) - 1
	For $i = 0 To $_UB_ - 1
		$_Verz_[$i] = $_Verz_[$i + 1]
	Next
	ReDim $_Verz_[$_UB_]
	For $_i_ In $_Verz_
		If (_F_L_S_($_Pfad_ & $_i_) = False) Then _Rekursiv_S_($_Pfad_ & $_i_, $_Wildc_, $_Flag_)
	Next
EndFunc   ;==>_Rekursiv_S_

Func _F_L_S_($_F_L_S_)
	Dim Static $_K_32_ = DllOpen('kernel32.dll')
	Dim $_D_A_ = DllCall($_K_32_, 'dword', 'GetFileAttributesW', 'wstr', $_F_L_S_)
	If (@error) Then Return SetError(0, @error, 0)
	Return BitAND($_D_A_[0], 1024) = 1024
EndFunc   ;==>_F_L_S_
#endregion UDF's